Changes to bldpkg:

* Updated TODO
* Added double quotes in some commands
* Fixed command explanation in help function
This commit is contained in:
PktSurf 2022-09-01 17:09:41 +05:30
parent 6b4699ccfb
commit 3fe6609c23

70
bldpkg
View file

@ -25,9 +25,7 @@
# -> Give a warning when more than two directories, a source and a staging directory
# not belonging to the current build are present inside tmpfs
# -> Write code to log build output to a log file inside a particular directory
# -> Write code to validate DISTCC_HOSTS variable
# -> Add code to show extended help?
# -> Is 'set -e' really needed? Multiple exits are already in use...
# -> Often times it happens that there are two package build files, one
# being the original package build file that has been backed up and the
# package build file whose stuff such as source directory extraction and
@ -37,6 +35,8 @@
# original package build file to be copied and not the modified package build
# file. Use -o <orig_bld_file> -m <modified_bld_file> for doing this, perhaps?
# -> Email the user about the outcome of the build?
# -> Remove double quotes next to command substitution statements
# -> Remove unnecessary PATH variable exports
# Determine whether we are using bash version 4 and later. If not, exit.
if ((BASH_VERSINFO[0] < 4)) ; then
@ -55,16 +55,15 @@ Bash script for building SMLinux-compatible packages from source.
Any option used as an argument with this script overrides the
corresponding option, if present, in /etc/bldpkg.conf or "'$HOME/.bldpkg.conf'"
If no arguments are provided, this script attempts to build a package
by matching the parent directory name with a build file that matches
that directory's name.
If no arguments are provided, this script attempts to first look for
a build file with a .SMBuild extension that matches the name of
the parent directory, sources that .SMBuild file and starts the build.
For example, if the build directory is $HOME/smlinux/alsa-lib, this script will
look and source from alsa-lib.SMBuild and build alsa-lib package if the user
has cd'd to $HOME/smlinux/alsa-lib
For example, if the package build directory is $HOME/smlinux/alsa-lib, this script will
look and source from alsa-lib.SMBuild and build alsa-lib package
# pwd
/home/smlinux/alsa-lib
/home/user/smlinux/alsa-lib
# ls
alsa-lib.SMBuild
@ -75,7 +74,8 @@ Building package 'alsa-lib' version '1.x'...
Usage:
-d : Produce a package with debug symbols preserved. Uses -g3 by default.
-d : Produce a package with debug symbols preserved, i.e., don't strip resulting
ELF objects. Uses -g3 by default.
-e : Extract the package installer file in the user's PWD if the build
completes successfully.
@ -83,8 +83,8 @@ Usage:
-f : Name of an alternate build file to source build variables. Should be
compatible with standard SMLinux package build file format.
-g : Generate SHA512 checksums of all tarballs and patches and insert them
into the package build file
-g : Generate SHA512 checksums of all tarballs and patches in the current
directory and insert them into the package build file
-h : Show this help message
@ -154,7 +154,7 @@ if [[ $OPTIND = 1 ]] ; then
echo "[ERROR] Try -f <build_file> if your build file has a different name (Not recommended)"
exit 1
else
source $buildfile
source "$buildfile"
fi
# If OPTIND is greater than 1, check if a build file matching the parent directory exists, and if it does, source it.
@ -175,14 +175,14 @@ elif [[ $OPTIND -gt 1 ]] ; then
# If $setbuildfile is set and is a file, set buildfile to its value, source it and initialise the build
if [[ -n $setbuildfile ]] && [[ -f $setbuildfile ]] ; then
buildfile="$setbuildfile"
source $buildfile
source "$buildfile"
# If $setbuildfile is set but a file passed as an argument is not found, give an error
elif [[ -n $setbuildfile ]] && [[ ! -f $setbuildfile ]] ; then
echo "[ERROR] $setbuildfile not found!"
exit 1
# If the above two conditions don't meet, get the presumed $buildfile value as a file and source it
elif [[ -f "$buildfile" ]] ; then
source $buildfile
source "$buildfile"
# If even that file is not found, throw an error and exit
else
echo "[ERROR] No package build file to source from!"
@ -210,9 +210,9 @@ if [[ $genchecksum = 1 ]] ; then
# For loop that searches for files matching the above extension
# and prints them to the bottom of the build file
for file in ${files[@]} ; do
for file in "${files[@]}" ; do
if [[ -f $file ]] ; then
sha512sum $file >> "$buildfile"
sha512sum "$file" >> "$buildfile"
fi
done
@ -273,7 +273,7 @@ if [[ ${#desc} -gt 100 ]] ; then
fi
# Check if build() function exists in the build file
if [[ ! "$(grep '^build()' $buildfile)" ]] ; then
if ! egrep -q '^build()' $buildfile ; then
echo "[ERROR] build() function does not exist in your build file."
exit 1
fi
@ -305,7 +305,7 @@ fi
terminateauditd() {
if [[ $useauditd = 1 ]] ; then
# Terminate auditd, log number of lines inside a variable
/bin/kill -15 $auditpid
/bin/kill -15 "$auditpid"
echo "[INFO] Auditd terminated."
auditlogtermsize="$(wc -l < $auditlogfile)"
@ -333,7 +333,7 @@ if [[ -z $skipchecksum ]] ; then
IFS=$'\n'
for src in $sums; do
for src in "$sums"; do
echo "$src" | sha512sum -c
checksumresult=$?
if [[ $checksumresult != 0 ]] ; then
@ -348,7 +348,7 @@ fi
# Function to output to the user which patch is about to be applied. Useful when there are many
# patches and you want to determine which patch failed.
applypatch() {
patchfile=$1
patchfile="$1"
if [[ -z $patchfile ]] ; then
echo "[ERROR] Please provide valid patch file name"
exit 1
@ -436,12 +436,12 @@ if [[ $htmloutput = 1 ]] ; then
<b>$commencedate | Building package # $currentpkgnumber / $totalpkgnumber: <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
else
cat << EOF >> $parenttmp/BUILDMONITOR
cat << EOF >> "$parenttmp/BUILDMONITOR"
<b>$commencedate | Building package <i><a href="/smlinux/pkgresults?pkg=$app&amp;smver=1.0&amp;arch=all&amp;resultnum=25">$app $version</a></i></b>
EOF
fi
touch $parenttmp/BUILDING
touch "$parenttmp/BUILDING"
fi
# Validate compressor and set extension
@ -469,7 +469,7 @@ case "$pkgext" in
esac
# Borrowed from slackware's installpkg utility
if ! $compressor --help > /dev/null 2>&1 ; then
if ! "$compressor" --help > /dev/null 2>&1 ; then
echo "[ERROR] '"$compressor"' Compressor validation failed."
exit 1
fi
@ -636,9 +636,9 @@ if [[ $globaldistcc = 1 ]] ; then
else
# Remove the common options along with the slash and the numbers after it
hosts="$(echo $DISTCC_HOSTS | sed -e 's@/[a-z0-9]*@@g' -e 's@--randomize@@' -e 's@localhost@@' -e 's@,lzo@@g')"
for host in ${hosts[@]} ; do
for host in "${hosts[@]}" ; do
# We only run distccd on TCP port 3632
if ! /bin/nc -z $host 3632 > /dev/null 2>&1 ; then
if ! /bin/nc -z "$host" 3632 > /dev/null 2>&1 ; then
echo "[WARNING] Distcc host '"$host"' is OFFLINE"
sleep 0.5
echo "Rewriting DISTCC_HOSTS"
@ -874,7 +874,7 @@ compileonlyfor() {
# usage: compileonlyfor <arch>
# will cause compilation to exit with 0 if uname -m does not match <arch>
archname="$(uname -m)"
archargument=$1
archargument="$1"
if [[ $archname != $archargument ]]; then
echo ""
@ -936,11 +936,11 @@ preprunitservice() {
# usage: $ preprunitservice <chrony> <down> <finish>
# Will create the chrony service directories with a down and a finish file to prevent auto-execution
# at next boot and to provide a clean exit respectively. Use the first argument to define the service name
rsname=$1
rsname="$1"
# Use the second argument to add the down file
down=$2
down="$2"
# Use the third argument to add the finish file
finish=$3
finish="$3"
# Enter the staging directory
cd "$pkg"
@ -998,7 +998,7 @@ mkfinalpkg() {
echo "[INFO] Leaving build directory $tmp"
echo "[INFO] Entering staging directory $pkg"
cd "$pkg"
echo "[INFO] Just a min..."
echo "[INFO] Performing packaging tasks..."
# Check if /lib64 was created inside $pkg
if [[ -d $pkg/lib64 ]] ; then
@ -1062,14 +1062,14 @@ EOF
echo "[INFO] Found share/doc/$app documentation directory."
echo "[INFO] Moving its contents into share/doc/$app-$version/"
mv $pkg/share/doc/$app/* $pkgdocs/
rmdir $pkg/share/doc/$app
rmdir "$pkg/share/doc/$app"
fi
# Normally we'd expect some debug symbols in the newly-produced binaries. But that isn't always the case with some
# packages whose build systems strip objects before hand
if [[ $debug = 1 ]] ; then
for file in \
$( find $pkg )
$( find "$pkg" )
do
file -m /etc/file/magic/elf $file | \
grep -E "executable|shared object" | \
@ -1449,7 +1449,7 @@ promptuser() {
read -r -p "[NOTIFY] Old test directory, if it exists already, will be overwritten. (y/N) " yn
case $yn in
case "$yn" in
[Yy]* ) echo "[INFO] Wise choice :-) ";
mkdir -p "$srcdir/test"
tar xvf "$newpkglocation" -C "$srcdir/test"
@ -1469,7 +1469,7 @@ promptuser() {
echo "[NOTIFY] '"$app"' successfully built and installprompt is enabled in the bldpkg.conf file."
read -r -p "[NOTIFY] Would you like to install/upgrade it? (y/N) " yn
case $yn in
case "$yn" in
[Yy]* ) echo "[INFO] Wise choice :-) "
upgradepkg --install-new "$newpkglocation"
break;;